/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.workload.provider;

import edu.kit.ipd.descartes.mm.workload.util.WorkloadAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class WorkloadItemProviderAdapterFactory extends WorkloadAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public WorkloadItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.workload.Workload} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected WorkloadItemProvider workloadItemProvider;

	/**
	 * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.workload.Workload}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createWorkloadAdapter() {
		if (workloadItemProvider == null) {
			workloadItemProvider = new WorkloadItemProvider(this);
		}

		return workloadItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.workload.UsageScenario} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected UsageScenarioItemProvider usageScenarioItemProvider;

	/**
	 * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.workload.UsageScenario}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createUsageScenarioAdapter() {
		if (usageScenarioItemProvider == null) {
			usageScenarioItemProvider = new UsageScenarioItemProvider(this);
		}

		return usageScenarioItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.workload.ScenarioBehavior} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ScenarioBehaviorItemProvider scenarioBehaviorItemProvider;

	/**
	 * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.workload.ScenarioBehavior}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createScenarioBehaviorAdapter() {
		if (scenarioBehaviorItemProvider == null) {
			scenarioBehaviorItemProvider = new ScenarioBehaviorItemProvider(this);
		}

		return scenarioBehaviorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.workload.OpenWorkloadType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OpenWorkloadTypeItemProvider openWorkloadTypeItemProvider;

	/**
	 * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.workload.OpenWorkloadType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createOpenWorkloadTypeAdapter() {
		if (openWorkloadTypeItemProvider == null) {
			openWorkloadTypeItemProvider = new OpenWorkloadTypeItemProvider(this);
		}

		return openWorkloadTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.workload.ClosedWorkloadType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ClosedWorkloadTypeItemProvider closedWorkloadTypeItemProvider;

	/**
	 * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.workload.ClosedWorkloadType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createClosedWorkloadTypeAdapter() {
		if (closedWorkloadTypeItemProvider == null) {
			closedWorkloadTypeItemProvider = new ClosedWorkloadTypeItemProvider(this);
		}

		return closedWorkloadTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.workload.StartUserAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StartUserActionItemProvider startUserActionItemProvider;

	/**
	 * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.workload.StartUserAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createStartUserActionAdapter() {
		if (startUserActionItemProvider == null) {
			startUserActionItemProvider = new StartUserActionItemProvider(this);
		}

		return startUserActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.workload.StopUserAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StopUserActionItemProvider stopUserActionItemProvider;

	/**
	 * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.workload.StopUserAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createStopUserActionAdapter() {
		if (stopUserActionItemProvider == null) {
			stopUserActionItemProvider = new StopUserActionItemProvider(this);
		}

		return stopUserActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.workload.LoopUserAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LoopUserActionItemProvider loopUserActionItemProvider;

	/**
	 * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.workload.LoopUserAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLoopUserActionAdapter() {
		if (loopUserActionItemProvider == null) {
			loopUserActionItemProvider = new LoopUserActionItemProvider(this);
		}

		return loopUserActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.workload.DelayUserAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DelayUserActionItemProvider delayUserActionItemProvider;

	/**
	 * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.workload.DelayUserAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDelayUserActionAdapter() {
		if (delayUserActionItemProvider == null) {
			delayUserActionItemProvider = new DelayUserActionItemProvider(this);
		}

		return delayUserActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.workload.BranchUserAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BranchUserActionItemProvider branchUserActionItemProvider;

	/**
	 * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.workload.BranchUserAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBranchUserActionAdapter() {
		if (branchUserActionItemProvider == null) {
			branchUserActionItemProvider = new BranchUserActionItemProvider(this);
		}

		return branchUserActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.workload.EntryLevelSystemCall} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EntryLevelSystemCallItemProvider entryLevelSystemCallItemProvider;

	/**
	 * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.workload.EntryLevelSystemCall}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEntryLevelSystemCallAdapter() {
		if (entryLevelSystemCallItemProvider == null) {
			entryLevelSystemCallItemProvider = new EntryLevelSystemCallItemProvider(this);
		}

		return entryLevelSystemCallItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.workload.CallParameterSetting} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CallParameterSettingItemProvider callParameterSettingItemProvider;

	/**
	 * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.workload.CallParameterSetting}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCallParameterSettingAdapter() {
		if (callParameterSettingItemProvider == null) {
			callParameterSettingItemProvider = new CallParameterSettingItemProvider(this);
		}

		return callParameterSettingItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (workloadItemProvider != null) workloadItemProvider.dispose();
		if (usageScenarioItemProvider != null) usageScenarioItemProvider.dispose();
		if (scenarioBehaviorItemProvider != null) scenarioBehaviorItemProvider.dispose();
		if (openWorkloadTypeItemProvider != null) openWorkloadTypeItemProvider.dispose();
		if (closedWorkloadTypeItemProvider != null) closedWorkloadTypeItemProvider.dispose();
		if (startUserActionItemProvider != null) startUserActionItemProvider.dispose();
		if (stopUserActionItemProvider != null) stopUserActionItemProvider.dispose();
		if (loopUserActionItemProvider != null) loopUserActionItemProvider.dispose();
		if (delayUserActionItemProvider != null) delayUserActionItemProvider.dispose();
		if (branchUserActionItemProvider != null) branchUserActionItemProvider.dispose();
		if (entryLevelSystemCallItemProvider != null) entryLevelSystemCallItemProvider.dispose();
		if (callParameterSettingItemProvider != null) callParameterSettingItemProvider.dispose();
	}

}
